
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>并发数据结构-1.1 并发的数据结构的设计 / iVAN</title>

    <meta name="description" content="并发数据结构-1.1 并发的数据结构的设计 原文链接,译文链接,译者:董明鑫,校对:周可人 随着多个处理器共享同一内存的机器在商业上的广泛使用,并发编程的艺术也产生了巨大的变化.当前的趋势向着低功耗芯片级多线程(CMT)发展,所以这样的机器一定会更加广泛的被使用. 共享内存多处理器是指并发的执行多个线程的系统,这些线程在共享的内存中通过数据结构通讯和同步.这些数据结构的效率对于性能是很关键的,而目前熟练掌握为多处理器机器设计高效数据结构这一技术的人并不多.对大多数人来说,设计并发的数据结构比设计单线程的难多了,因为并发执行的线程可能会多种">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">并发数据结构-1.1 并发的数据结构的设计</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><a href="http://www.cs.tau.ac.il/~shanir/concurrent-data-structures.pdf" rel="external nofollow noreferrer">原文链接</a>，<a href="http://ifeve.com/concurrent-data-structures1-1/" rel="external nofollow noreferrer">译文链接</a>，译者：董明鑫，校对：周可人</p>
<p>随着多个处理器共享同一内存的机器在商业上的广泛使用，并发编程的艺术也产生了巨大的变化。当前的趋势向着低功耗芯片级多线程（CMT）发展，所以这样的机器一定会更加广泛的被使用。</p>
<p>共享内存多处理器是指并发的执行多个线程的系统，这些线程在共享的内存中通过数据结构通讯和同步。这些数据结构的效率对于性能是很关键的，而目前熟练掌握为多处理器机器设计高效数据结构这一技术的人并不多。对大多数人来说，设计并发的数据结构比设计单线程的难多了，因为并发执行的线程可能会多种方式地交错运行他们的指令，每一种方式会带来不同的，甚至不符合预期的输出。这就要求设计者改变他们对运算的认识，理解新的设计方法，采用新的编程工具集。此外，设计可扩展的并发数据结构，使得当机器执行越来越多的并发线程时依旧表现良好也是新的挑战。本文主要介绍设计并发数据结构的相关挑战，和一些重要的数据结构相关内容的总结。我们的总结绝不是全面的；相反，我们特意选取了一些能说明设计的关键问题的流行的数据结构，希望我们提供了足够的背景和知识，让有兴趣的读者接触那些我们没有提到的内容。</p>
<h3>1.1 并发的数据结构的设计</h3>
<p>共享内存多处理器的一些特性使得并发数据结构的设计和校验比相对应的单线程结构难度显著增加。<br /><code></code></p>
<p>acquire(Lock);</p>
<p>oldval = X;                                                                                      oldval = X;</p>
<p>X = oldval + 1;                                                                                X = oldval + 1;</p>
<p>return oldval;                                                                                 release(Lock);</p>
<p>return oldval;</p>
<p>图1.1：顺序的和基于锁机制的fetch-and-inc操作代码片段</p>
<p>难点的根源在于并发：因为线程是在不同的处理器上并发的执行，而且受操作系统的调度决策、缺页、中断等等影响，我们必须按照全部异步的想法来思考，以保证不同的线程能够随意交错的运行。这显著提升了正确设计并发数据结构的复杂度。</p>
<p>为多处理器系统设计并发的数据结构在性能和可扩展性上也有大量的挑战。在现代的机器上，处理器和内存的布局、数据在内存中的布局、多处理器体系结构中各个元素间的通信负载全都对性能有影响。此外，正确性和性能两者联系非常的紧密：算法的改进在提高性能的同时经常使其更加难以设计和检验正确的数据结构实现。</p>
<p>下面的例子阐述了影响数据结构设计的各个多处理器特征。假设我们想要实现一个共享的计数器数据结构，用于支持fetch-and-inc操作，即计数器加一然后返回增加前的值。一个普通的顺序fetch-and-inc实现的代码就如图1.1中左边部分所展示的那样。</p>
<p>如果我们允许多个线程并发地调用fetch-and-inc操作，上述实现运行起来并不正确。来看看原因，注意大多数编译器会把这份源代码转换成机器指令：把 X 的值装进一个寄存器，然后把寄存器中的值加一，然后再把这个寄存器的值存回 X 。假如计数器初始化为 0 ，两个不同的处理器并发的执行两个fetch-and-inc操作。然后就有可能两个操作都从 X 中读出 0 ，然后都把 1 存回 X 并且返回 0 。这显然是不正确的：两个操作中有一个应该返回 1 。</p>
<p>如上所述，两个fetch-and-inc操作不正确的交错结果导致了不正确的行为。一个自然并且普通的方法来阻止这样的交错就是用互斥锁（也被叫做 mutex 或者 lock）。锁是一个在任意时间点，都是不被（其他线程）获取，只被一个线程所获取的构造。如果一个线程 t1 希望获取已经被另一个线程 t2 所获取到的锁，那么 t1 必须等到 t2 释放这个锁。</p>
<p>如图 1.1 右半部分所示，我们能通过锁机制得到一个正确的顺序实现。我们通过阻止所有的交错来预防坏的交错。这样很容易得到一个正确的共享计数器，然而这种简单是有代价的：锁机制引发了许多关于性能和软件工程上的问题。 </p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-19 22:02:45</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>并发数据结构-1.1 并发的数据结构的设计的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mxo0Dyb.html" rel="bookmark">C&num;并发编程经典实例--并发编程概述</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				来自 &quot;C#并发编程经典实例&quot; 优秀软件的一个关键特征就是具有并发性.过去的几十年,我们可以进行并发编程,但是难度很大.以前,并发性软件的编写.调试和维护都很难,这导致很多开发人员为图省事放弃了并发编程.新版.NET 中的程序库和语言特征,已经让并发编程变得简单多了.随着Visual Studio 2012 的发布,微软明显降低了并发编程的门槛.以前只有专家才能做并发编程,而今天,每一个开发人员都能够(而且应该)接受并发编程. 1.1 并发编程简介 首先,我来解释几个贯穿本书始终的术语			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvWKnrp.html" rel="bookmark">Java 并发&sol;多线程教程&lpar;四&rpar;-并发模型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				       本系列译自jakob jenkov的Java并发多线程教程(本章节部分内容参考http://ifeve.com/并发编程模型),个人觉得很有收获.由于个人水平有限,不对之处还望矫正!        并发系统可以有多种并发模型来实现,并发模型指定线程如何协同完成分配给他们的任务.不同的并发模型以不同的方式划分任务,并且线程与线程之间以不同的方式进行通信和协作. 并发模型与分布式系统的相似性          本文中描述的并发模型类似于分布式系统中使用的不同体系结构.在并发系统中,不同			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLm68kz.html" rel="bookmark">MFC定时器伪并发区别于多线程并发的理解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 MFC定时器伪并发区别于多线程并发的理解 是不是这么理解MFC定时器伪并发?因为定时器是基于中断技术的,所以只有一个cpu执行,效率低,多线程是基于操作系统的,所以是多cpu执行,效率高? 解决方案 http://bbs.csdn.net/topics/390609917			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze0GWAp.html" rel="bookmark">MFC定时器实现伪并发，定时器的并发怎么才能顺序执行呢？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 MFC定时器实现伪并发,定时器的并发怎么才能顺序执行呢? MFC定时器实现伪并发,定时器的并发怎么才能顺序执行呢?消息的参数传递怎么保持? 解决方案 既然是并发,就是同时执行,况且定时器其实根本不算什么并发,本来定时器就是放在主线程中顺序执行的.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn4PWOb.html" rel="bookmark">定时器并发改写成多线程并发造成CPU上不来</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 定时器并发改写成多线程并发造成CPU上不来 多线程并发CPU上不来是不是说明有线程一致没有被执行?但是为什么线程没有执行,结果数组却被改写了? 解决方案 用process explorer这个工具看下你的线程有没有执行,还是锁住了.			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5R8ADz.html" rel="bookmark">Oracle官方并发教程之高级并发对象</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文地址,译文地址 译者:李任 目前为止,该教程重点讲述了最初作为Java平台一部分的低级别API.这些API对于非常基本的任务来说已经足够,但是对于更高级的任务就需要更高级的API.特别是针对充分利用了当今多处理器和多核系统的大规模并发应用程序. 本节,我们将着眼于Java 5.0新增的一些高级并发特征.大多数特征已经在新的java.util.concurrent包中实现.Java集合框架中也定义了新的并发数据结构. 锁对象提供了可以简化许多并发应用的锁的惯用法. Executors为加载和管			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxWkBOb.html" rel="bookmark">无锁并发和无等待并发的对比分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文地址:作者:rethinkdb  译者:sooerr 校对:方腾飞 有两种非阻塞线程同步算法,即无锁和无等待,这两种算法经常会产生混淆. 在无锁系统中,当任何特定的运算被阻塞的时候,所有CPU可以继续处理其他的运算.换种方式说,在无锁系统中,当给定线程被其他线程阻塞的时候,所有CPU可以不停的继续处理其他工作.无锁算法大大增加系统整体的吞吐量,因为它只偶尔会增加一定的交易延迟.大部分高端数据库系统是基于无锁算法而构造的,以满足不同级别. 相反,无等待算法保证了所有CPU在连续处理有效工作的时			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0QNXmp.html" rel="bookmark">数据结构    c语言-C语言数据结构课程设计实现一个集合数据结构</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 C语言数据结构课程设计实现一个集合数据结构 题目:设计并实现一个集合数据结构Set.一个集合中没有重复元素,支持下列运算: boolean add(E o) 如果 set 中尚未存在指定的元素o,则添加此元素. boolean addAll(Set c) 如果 set 中没有指定集合c中的所有元素,则将其添加到此 set 中. void clear() 移除 set 中的所有元素. boolean contains(E o) 如果 set 包含指定的元素o,则返回 true. bool			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn74erz.html" rel="bookmark">并发编程11-测试并发程序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				测试的两个方面: - 安全性 并发不会造成状态错误. - 活跃度 主要是性能测试 - 吞吐量 段时间定资源内可以处理的任务数量 - 响应性 从请求到完成一些动作之前的延迟(等待执行的时间) - 可伸缩性 增加资源,提高性能 正确性测试 所有加入队列的都会被执行: 一般的可行的办法是把加入队列的列表和消费的列表保存起来进行比较.但是因为会设计资源的并发,影响对本身的测试,比较好的办法是在队列中加入唯一的id,然后对id求和,消费时同样求和,来比较结果.这样能最小的影响实际要测试的结果. publi			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9MxDGjM.html" rel="bookmark" class="title">避免表格被撑开变形 用CSS实现的方法</a>
					<div>
						css 如何避免表格因为图片尺寸或者过长的英文字符而变形撑开,在CSS加入以下代码就可以防止,同时英文单词也会按单词断行,不是按字母这个.我想说的是这个在CSS2.0是不支持的,但是能解决一些实际问题 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMgBKAb.html" rel="bookmark" class="title">有图有真相 搜索引擎识别关键词途径探析</a>
					<div>
						何谓关键词?和论文写作一样,网站的关键词就是一个网站的主题,或者网站某一个页面的内容核心所在.甚至可以理解为,网站内容所围绕的一个中心,内容和什么相关.比如以网站建设为主要内容的网站,就可以将关键词确 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPry0b.html" rel="bookmark" class="title">网站SEO外链的数量与质量谁更重要</a>
					<div>
						很多朋友可能都知道,外链对一个网站在搜索引擎里的权重很重要,那么外链是越多越好吗,我个人觉得,不一定.以前看到过1分钟产生成千上万的外链工具,也使用过后效果并不好,尤其是新站很可能事得其反.一般我们站 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLR5Zb.html" rel="bookmark" class="title">Windows Home Server安装和配置体验</a>
					<div>
						gOxiA 早在两个月前就进行了 Windows Home Server(WHS)简单的体验,不过因为是英文版还是安装 在远程的 Hyper-V 上,所以测试起来相当慢,最近正好以 Native Bo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0P2eAM.html" rel="bookmark" class="title">android&period;app&period;Activity---中文</a>
					<div>
						Android.app.Activity Activity是用户主要也是唯一打交道的途径.基本上所有的Activity都是和用户打交道的,你可以通过setContentView(View)来创建一个窗 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKy88M.html" rel="bookmark" class="title">Delphi与DirectX之DelphiX&lpar;92&rpar;&colon; TDIB&period;Draw3x3Matrix&lpar;&rpar;&semi;</a>
					<div>
						本例效果图: 代码文件: unit Unit1; interface uses Windows, Messages, SysUtils, Variants, Classes, Graphics, Co ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm7xv7b.html" rel="bookmark" class="title">gridview自动排序示例分享</a>
					<div>
						 GridView自带了数据排序功能.在设计视图下,只能对GridView的排序数据列和排序方向进行静态设置.在后台程序中,则需要用Attributes方式对GridView的这两个属性进行动态设置  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnxN60b.html" rel="bookmark" class="title">PS计算选区对人物肖像进行分区锐化方法教程</a>
					<div>
						分区[影调]全局锐化:是基于明度的不同,锐化的反应也不相同来的,是比较高级的锐化技巧之一.高光区本来反差就大. 对锐化比较敏感.需要的锐化量针对较小.中间调的反差相对于高光区小,比高光区需要的锐化量要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6eePXb.html" rel="bookmark" class="title">Win8怎么打开Windows Defender？</a>
					<div>
						  1.系统下同时按住键盘上 &quot; Windows&quot; 和 &quot;X&quot; 键打开系统菜单 ,选择&quot;控制面板&quot;; 2.选择&quot; Windows  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze70BwM.html" rel="bookmark" class="title">Xshell 配置文件备份方法介绍</a>
					<div>
						  Step1 打开Xshell Step2 点击FILES -&gt; OPEN,弹出一个新的窗口,点击此窗口中的文件夹小图标,如下图 Step3 出现session的存储路径,如下图 Step4  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxW6yQb.html" rel="bookmark" class="title">如何统一修改Win8系统文件夹视图模式</a>
					<div>
						Win8文件夹的视图模式有很多种,有大图标.小图标.详细信息等,每个视图模式都有它的好处,我们平时在浏览文件的时候也都会根据自己需求设置相应的视图模式,每个文件夹都有各自的视图,当改变某个文件夹的视图 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlBd28z.html" rel="bookmark" class="title">酷我音乐盒无法连接网络怎么解决</a>
					<div>
						酷我音乐盒无法连接网络解决方法: 1.打开浏览器,点&quot;工具&quot;→Internet选项→&quot;管理加载项&quot;那里禁用所有可疑插件,或者你能准确知道没问题的保留. 然后工具 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MywJj5z.html" rel="bookmark" class="title">指定默认磁盘配额限量和警告级别</a>
					<div>
						  这个设置决定计算机上每个NTFS文件系统卷上每个用户可以使用的磁盘空间量,同时,还指定警告级别. 运行注册表编辑器,打开HKEY_LOCAL_MACHINESoftwarePoliciesMicr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkGo7dp.html" rel="bookmark" class="title">jsp、html-为什么我判断后男女性别都出来了</a>
					<div>
						问题描述 为什么我判断后男女性别都出来了 &lt;tr align=&quot;center&quot;&gt;&lt;td width=&quot;50%&quot; align=&quot;rig ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boRdWdz.html" rel="bookmark" class="title">PS打造燃烧的LOVE效果字</a>
					<div>
						火焰字的制作方法有很多.最简单的就是直接用火焰素材来制作.本教程介绍的为最基础的手工制作.大致过程:先用滤镜及调色工具把文字特殊处理.然后用涂抹工具来涂抹火焰效果.最后调整颜色即可. 最终效果 1.一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDWvdWp.html" rel="bookmark" class="title">【Linux shell】tar命令排除某些文件打包</a>
					<div>
						1.--exclude 参数使用 --exclude dirname/filename 排除某个目录或某个文件后压缩打包. 例如: cd /etc/openvpn tar --exclude easy ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVN88lz.html" rel="bookmark" class="title">flex 弹出窗口的内存优化问题</a>
					<div>
						问题描述 flex 弹出窗口的内存优化问题 有个功能要用到?ExtendedNativeWindow,功能完成后,进行优化内存. 发现ExtendedNativeWindow弹出,然后立刻关闭后的内存 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ND9Bz.html" rel="bookmark" class="title">atastage 9 1-Datastage 9&period;1 ETL工程出现中文乱码</a>
					<div>
						问题描述 Datastage 9.1 ETL工程出现中文乱码 DataStage Administrator中NLS设置为GB1232, 在DataStage designer中从源数据中抽取表数据, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnK06jz.html" rel="bookmark" class="title">小米手机藏后门可远程安装任意APP？真相如此惊悚吗？</a>
					<div>
						    这个乡村爱情故事可能和今天要说的事情有点关系. 你可能已经习惯了这个场景--新手机会预装一些APP,怎么删都删不掉.但是,手机制造商将这些APP和服务安装在你手机上是否会有特别的目的?这些预装 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z40A31z.html" rel="bookmark" class="title">动视EA诉讼大战愈演愈烈 专家认为各方都将损失惨重</a>
					<div>
						(编译/毛狒甜)看来动视和Infinity Ward创始人Jason West和Vince Zampella之间的官司还远没有结束,并且向着更严重的方向发展了.本周二动视展开了新的一轮起诉,这次把Ja ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRAD8b.html" rel="bookmark" class="title">域名限制明年取消：公司名称可作后缀</a>
					<div>
						早报记者 曹敏洁 网站域名后缀限制明年将被取消,任何词语都可以被用作顶级域名后缀,厂商们也可以将自己的公司名作为域名后缀使用,类似&quot;.google&quot;.&quot;.coke&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDe6Yrb.html" rel="bookmark" class="title">arcgis js 实现书签入库</a>
					<div>
						问题描述 arcgisjs实现bookmark入库 解决方案 解决方案二:用Arcgis建一个mdb,把你要入库的图层导进去入库之后对照你的建库标准把你的数据规范化一下比如增加标识码.要素代码等必要字 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeR1e7b.html" rel="bookmark" class="title">安妮教育发布BeonU网站</a>
					<div>
						本报讯 记者李杨报道 近日,安妮教育在京http://www.aliyun.com/zixun/aggregation/549.html&quot;&gt;发布了搜索及互动平台BeonU(超越网).该 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4eLyJb.html" rel="bookmark" class="title">C&plus;&plus;：传值与传地址</a>
					<div>
						    参数的传递方式有两种:传值和传地址.        传值 传值方式是将实参的值复制到形参中,因此实参和形参是两个不同的变量,各有各的存储空间,函数形参可以看做是函数的局部变量.如图: 传值的最 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjQ28M.html" rel="bookmark" class="title">java swing给控件增加快捷键</a>
					<div>
						如何给swing 控件增加快捷键呢? 场景:  当光标聚焦在password 文本框时,按Alt+Enter键,使username文本框聚焦.如何实现呢? Java代码   /***       *  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYRD8b.html" rel="bookmark" class="title">求助高手帮忙讲解一下这段代码</a>
					<div>
						问题描述 publicstaticstringcertifyReturnArray(stringdecryptString){stringtext4;try{stringtext1=&quot;Dcm ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdmmexz.html" rel="bookmark" class="title">Zend Framework教程之Zend&lowbar;Config&lowbar;Ini用法分析&lowbar;php实例</a>
					<div>
						本文实例讲述了Zend Framework教程之Zend_Config_Ini用法.分享给大家供大家参考,具体如下: Zend_Config_Ini允许开发者通过嵌套的对象属性语法在应用程序中用熟悉的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXK9EjM.html" rel="bookmark" class="title">C&plus;&plus; 关于 CMFCPropertyGridCtrl 的使用方法&lowbar;C 语言</a>
					<div>
						题外话: 最近在写一个重要的程序,想做的更灵活一些,于是想采用属于对话框的形式,如图所示 但查了好几本大部门的C++及MFC的书,还有很多的网上的资料,这方面的介绍实在是少之又少.不过,好在VS201 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr2lX1M.html" rel="bookmark" class="title">如何在Google新算法中拔得头筹</a>
					<div>
						     如何应对Google的新算法?大家可以根据下面所列的一些要点采取相应的措施.3-1. 关键词的研究:扩大覆盖面     搜索引擎策略的中心思想是确定恰当的关键词来锁定目标群体.但有很多网站管 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8NDAob.html" rel="bookmark" class="title">Installshield停止操作系统进程的代码--IS5版本适用</a>
					<div>
						原文:Installshield停止操作系统进程的代码--IS5版本适用出处:http://www.installsite.org/pages/en/isp_ext.htm这个地址上有不少好东西,有空 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
